local function List(pn)
	return GAMESTATE:GetCurrentSong():GetStepsByStepsType(GAMESTATE:GetCurrentSteps(pn):GetStepsType())
end

local function Values(pn)	
	local ret = {}
	for _,v in ipairs(List(pn)) do
		ret[#ret+1] = ToEnumShortString(v:GetDifficulty()).." "..v:GetMeter()
	end
	return ret
end

local function Default(pn)
	return ToEnumShortString(GAMESTATE:GetCurrentSteps(pn):GetDifficulty()).." "..GAMESTATE:GetCurrentSteps(pn):GetMeter()
end	

return function(pn)
	return {
		Name = "Step"..ToEnumShortString(pn),
		LayoutType = "ShowAllInRow",
		SelectType = "SelectOne",
		OneChoiceForAllPlayers = true,
		ExportOnChange = false,
		Choices = Values(pn),
		Values = Values(pn),
		LoadSelections = function(self, list)
			for i,v in pairs(self.Values) do
				if v == Default(pn) then
					list[i] = true
				end
			end
		end,
		SaveSelections = function(self, list)
			for i,v in pairs(self.Values) do
				if list[i] then
					GAMESTATE:SetCurrentSteps(pn,List(pn)[i])
				end
			end
		end
	}
end
